{
        This Code Was Created By Jan Koci 2002
        Visit My Site At http://koci.opengl.cz
}

// Unita, ktera vykresluje objekty

unit KDrawObjects;

interface

uses OpenGL;


procedure CalculateRainbow;  //vypocita body pro vykreslovani duhy
procedure DrawRainbow;    //vykreslovani duhy

implementation

uses KTextures, KMath;


type TPoint3D=record    //typ pro 3d vrchol trojuhelnika
     x: TGLFloat;
     y: TGLFloat;
     z: TGLFloat;
end;

var
  RainbowVertex: array [0..37] of TPoint3d;    //nastav pole 38 vrcholu


procedure CalculateRainbow;
var
  angle: integer;    //uhel
  x, y: double;    //body vrcholu
  radius: double;    //polomer
  i: integer;    //promenna pro cyklus
begin
   angle := 0;    //nastav uhel na 0
   i := 0;    //nastav i na 0

   while angle <= 180 do    //pokud bude uhel mensi nebo rovno 180 stupnu
   begin
     radius := 3;    //nastav polomer na 3
     x := radius * sin(RadToGrad(angle-90));    //vypocti pozici bodu x
     y := radius * sin(RadToGrad(angle));    //vypocti pozici bodu y
     RainbowVertex[i].x := x;    //bod x prirad bodu x jednoho z vnitrnich vrcholu
     RainbowVertex[i].y := y;    //bod y prirad bodu y jednoho z vnitrnich vrcholu

     i := i + 1;    //pricti 1
     radius := radius + 1;    //pricti polomer 1
     x := radius * sin(RadToGrad(angle-90));    //vypocti pozici bodu x
     y := radius * sin(RadToGrad(angle));    //vypocti pozici bodu y
     RainbowVertex[i].x := x;    //bod x prirad bodu x jednoho z vnejsich vrcholu
     RainbowVertex[i].y := y;    //bod y prirad bodu y jednoho z vnejsich vrcholu

     i := i + 1;    //pricti 1
     angle := angle + 10;    //pricti uhel 10 stupnu
   end;

end;



procedure DrawRainbow;
var
  i: integer;    //promenna pro cyklus
begin
    i := 0;    //nastav i na 0

    glEnable(GL_TEXTURE_1D);    //zapni 1D texturovani
    glCallList(1);    //nacti texturu z Listu cislo 1  (RainbowTexture)

    glPushMatrix;    //zacatek prostorove matice
    glTranslatef( 0.0, -1.0, -8.0);    //pohni trojuhelnikem -1.0 dolu o 8.0 od kamery
    while(i < 35) do    //opakuj, dokud nevykreslis 36 trojuhelniku
    begin
      glBegin(GL_TRIANGLES);    //zacni vykreslovat trojuhelnik
        //prvni trojuhelnik
        glTexCoord2f(0,0);    //texturova koordinace (levy horni vrchol textury)
        glVertex3f( RainbowVertex[i].x, RainbowVertex[i].y, 0.0);    //levy dolni vrchol
        glTexCoord2f(1,0);    //texturova koordinace (pravy horni vrchol textury)
        glVertex3f( RainbowVertex[i+1].x, RainbowVertex[i+1].y, 0.0);    //levy horni vrchol
        glTexCoord2f(0,1);    //texturova koordinace  (levy dolni vrchol textury)
        glVertex3f( RainbowVertex[i+2].x, RainbowVertex[i+2].y, 0.0);    //pravy dolni vrchol

        //druhy trojuhelnik
        glTexCoord2f(1,1);    //texturova koordinace (pravy dolni vrchol textury)
        glVertex3f( RainbowVertex[i+3].x, RainbowVertex[i+3].y, 0.0);    //pravy horni vrchol
        glTexCoord2f(0,1);    //texturova koordinace (levy dolni vrchol textury)
        glVertex3f( RainbowVertex[i+2].x, RainbowVertex[i+2].y, 0.0);    //pravy dolni vrchol
        glTexCoord2f(1,0);    //texturova koordinace  (pravy horni vrchol textury)
        glVertex3f( RainbowVertex[i+1].x, RainbowVertex[i+1].y, 0.0);    //levy horni vrchol
      glEnd();  //ukonci vykreslovani trojuhelnika

      i := i + 2;    //pricti dvojku aby se dalsi trojuhelniky nekreslili pres predesle
    end;
    glPopMatrix;    //konec prostorove matice
end;


end.
